Before engaging with the runtime data binding APIs, it is important to familiarize yourself with the core concepts presented in the Overview.
View Models
View models describe a set of properties, but cannot themselves be used to get or set values - that is the role of view model instances.
To begin, we need to get a reference to a particular view model. This can be done either by index, by name, or the default for a given artboard, and is done from the Rive file. The default option refers to the view model assigned to an artboard by the dropdown in the editor.
import { useRiveFile } from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
// Get reference by name
const namedVM = riveFile?.viewModelByName('My View Model');
// Get reference by index
const indexVM = riveFile?.viewModelByIndex(0);
// Get reference to the default artboard view model
const defaultVM = riveFile?.defaultArtboardViewModel();
Creating a view model object is only supported in the new React Native runtime.
View Model Instances
Once we have a reference to a view model, it can be used to create an instance. When creating an instance, you have four options:
-
Create a blank instance - Fill the properties of the created instance with default values as follows:
| Type | Value |
|---|
| Number | 0 |
| String | Empty string |
| Boolean | False |
| Color | 0xFF000000 |
| Trigger | Untriggered |
| Enum | The first value |
| Image | No image |
| Artboard | No artboard |
| List | Empty list |
| Nested view model | Null |
-
Create the default instance - Use the instance labelled “Default” in the editor. Usually this is the one a designer intends as the primary one to be used at runtime.
-
Create by index - Using the order returned when iterating over all available instances. Useful when creating multiple instances by iteration.
-
Create by name - Use the editor’s instance name. Useful when creating a specific instance.
In some samples, due to the wordiness of “view model instance”, we use the abbreviation “VMI”, as well as “VM” for “view model”.
Use the useViewModelInstance hook to create a view model instance. You can pass a RiveFile, ViewModel, or RiveViewRef as the source.import { useRiveFile, useViewModelInstance, RiveView } from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
// From RiveFile — default artboard's ViewModel, default instance
const instance = useViewModelInstance(riveFile);
// Specify artboard or ViewModel name (mutually exclusive)
const instance = useViewModelInstance(riveFile, { artboardName: 'MainArtboard' });
const instance = useViewModelInstance(riveFile, { viewModelName: 'Settings' });
// instanceName can be combined with any of the above to pick a specific instance
const instance = useViewModelInstance(riveFile, { instanceName: 'PersonInstance' });
const instance = useViewModelInstance(riveFile, { viewModelName: 'Settings', instanceName: 'UserSettings' });
// From a ViewModel object
const viewModel = riveFile?.viewModelByName('My View Model');
const namedInstance = useViewModelInstance(viewModel, { name: 'My Instance' });
const newInstance = useViewModelInstance(viewModel, { useNew: true });
// With required: true (throws if null, use with Error Boundary)
const instance = useViewModelInstance(riveFile, { required: true });
// With onInit to set initial values synchronously
const instance = useViewModelInstance(riveFile, {
onInit: (vmi) => {
vmi.numberProperty('health')!.value = 100;
},
});
return (
<RiveView file={riveFile} dataBind={instance} />
);
You can also get the auto-bound instance from a RiveViewRef:import { useRive, useViewModelInstance } from '@rive-app/react-native';
const { riveViewRef, setHybridRef } = useRive();
const instance = useViewModelInstance(riveViewRef);
You can bind a view model instance to a Rive component by passing in a dataBinding prop to the Rive component.The dataBinding prop accepts a DataBindBy type, which can be one of the following:export type DataBindBy =
| { type: 'autobind'; value: boolean }
| { type: 'index'; value: number }
| { type: 'name'; value: string }
| { type: 'empty' };
export const AutoBind = (value: boolean): DataBindBy => ({
type: 'autobind',
value,
});
export const BindByIndex = (value: number): DataBindBy => ({
type: 'index',
value,
});
export const BindByName = (value: string): DataBindBy => ({
type: 'name',
value,
});
export const BindEmpty = (): DataBindBy => ({ type: 'empty' });
Example usage:const [setRiveRef, riveRef] = useRive();
return (
<Rive
ref={setRiveRef}
autoplay={true}
dataBinding={AutoBind(true)} // default: `AutoBind(false)`
// dataBinding={BindByIndex(0)}
// dataBinding={BindByName('SomeName')}
// dataBinding={BindEmpty()}
stateMachineName={'State Machine 1'}
resourceName={'rewards'}
/>
);
You can listen to errors by passing in the onError={(riveError: RNRiveError) prop to the Rive component.
The riveError object contains the error type and message, and you can filter out for RNRiveErrorType.DataBindingError:onError={(riveError: RNRiveError) => {
switch (riveError.type) {
case RNRiveErrorType.DataBindingError: {
console.error(`${riveError.message}`);
return;
}
default:
console.error('Unhandled error');
return;
}
}}
Binding
The created instance can then be assigned to a state machine or artboard. This establishes the bindings set up at edit time.
It is preferred to assign to a state machine, as this will automatically apply the instance to the artboard as well. Only assign to an artboard if you are not using a state machine, i.e. your file is static or uses linear animations.
The initial values of the instance are not applied to their bound elements until the state machine or artboard advances.
For React Native, no additional steps are needed to bind the view model instance to the Rive component. Pass the instance to the dataBind prop on RiveView:import { RiveView, useRiveFile, useViewModelInstance } from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
return (
<RiveView
file={riveFile}
dataBind={instance}
/>
);
For React Native, no additional steps are needed to bind the view model instance to the Rive component. The dataBinding prop handles this automatically.
Auto-Binding
Alternatively, you may prefer to use auto-binding. This will automatically bind the default view model of the artboard using the default instance to both the state machine and the artboard. The default view model is the one selected on the artboard in the editor dropdown. The default instance is the one marked “Default” in the editor.
Auto-binding is available through the DataBindMode enum. You can pass DataBindMode.Auto to the dataBind prop:import { RiveView, useRiveFile, DataBindMode } from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
return (
<RiveView
file={riveFile}
dataBind={DataBindMode.Auto}
autoPlay={true}
/>
);
You can also bind by name:<RiveView
file={riveFile}
dataBind={{ byName: 'My Instance' }}
autoPlay={true}
/>
Or bind a specific instance:const instance = useViewModelInstance(riveFile);
<RiveView
file={riveFile}
dataBind={instance}
autoPlay={true}
/>
The default value for the dataBinding prop is AutoBind(false), which means auto-binding is disabled by default.To enable auto-binding, set the dataBinding prop to AutoBind(true).const [setRiveRef, riveRef] = useRive();
return (
<Rive
ref={setRiveRef}
autoplay={true}
dataBinding={AutoBind(true)} // default: `AutoBind(false)`
stateMachineName={'State Machine 1'}
resourceName={'rewards'}
/>
);
Properties
A property is a value that can be read, set, or observed on a view model instance. Properties can be of the following types:
| Type | Supported |
|---|
| Floating point numbers | ✅ |
| Booleans | ✅ |
| Triggers | ✅ |
| Strings | ✅ |
| Enumerations | ✅ |
| Colors | ✅ |
| Nested View Models | ✅ |
| Lists | ✅ |
| Images | ✅ |
| Artboards | ✅ |
For more information on version compatibility, see the Feature Support page.
Listing Properties
Property descriptors can be inspected on a view model to discover at runtime which are available. These are not the mutable properties themselves though - once again those are on instances. These descriptors have a type and name.
The properties API is not supported on the legacy runtime.
Reading and Writing Properties
References to these properties can be retrieved by name or path.
Some properties are mutable and have getters, setters, and observer operations for their values. Getting or observing the value will retrieve the latest value set on that property’s binding, as of the last state machine or artboard advance. Setting the value will update the value and all of its bound elements.
After setting a property’s value, the changes will not apply to their bound elements until the state machine or artboard advances.
Use the specific hooks for each property type to get and set property values:
useRiveBoolean: Read/write boolean properties
useRiveString: Read/write string properties
useRiveNumber: Read/write number properties
useRiveColor: Read/write color properties with hex string or RGBA support
useRiveEnum: Read/write enum properties
useRiveTrigger: Fire trigger events with optional callbacks
These hooks return the current value, a setter function (setValue or trigger), and an error if the property is not found.The setValue function allows you to pass a function that receives the previous value, similar to React’s setState pattern. This is useful when you need to update a value based on its current state:setValue((v) => (v ?? 0) + 5)
import {
useRiveFile,
useViewModelInstance,
useRiveBoolean,
useRiveString,
useRiveNumber,
useRiveColor,
useRiveEnum,
useRiveTrigger,
RiveView
} from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
// Boolean
const { value: isActive, setValue: setIsActive, error: boolError } = useRiveBoolean(
'isToggleOn',
instance
);
// Set: setIsActive(true);
// String
const { value: userName, setValue: setUserName, error: stringError } = useRiveString(
'user/name',
instance
);
// Set: setUserName('Rive');
// Number
const { value: score, setValue: setScore, error: numberError } = useRiveNumber(
'levelScore',
instance
);
// Set: setScore(100);
// Color (accepts hex string or RiveColor object)
const { value: themeColor, setValue: setThemeColor, error: colorError } = useRiveColor(
'ui/themeColor',
instance
);
// Set: setThemeColor('#FF0000FF'); // hex string
// Or: setThemeColor({ r: 255, g: 0, b: 0, a: 255 }); // RGBA object
// Enum
const { value: status, setValue: setStatus, error: enumError } = useRiveEnum(
'appStatus',
instance
);
// Set: setStatus('loading');
// Trigger (No value, just a trigger function)
const { trigger: playEffect, error: triggerError } = useRiveTrigger(
'playButtonEffect',
instance,
{
// Optional callback to be called when the trigger is fired
onTrigger: () => {
console.log('Trigger Fired!');
}
}
);
// Trigger: playEffect();
return (
<RiveView
file={riveFile}
dataBind={instance}
autoPlay={true}
/>
);
The value returned by each hook will update automatically when the property changes in the Rive graphic. The following data binding methods are exposed on the RiveRef object.setBoolean: (path: string, value: boolean) => void;
setString: (path: string, value: string) => void;
setNumber: (path: string, value: number) => void;
setColor: (path: string, color: RiveRGBA | string) => void;
setEnum: (path: string, value: string) => void;
trigger: (path: string) => void;
The color property can be set using either a RiveRGBA object or a hex string. The hex string should be in the format
#RRGGBBAA, where RR, GG, BB, and AA are two-digit hexadecimal values representing the red, green, blue, and
alpha channels, respectively.type RiveRGBA = { r: number; g: number; b: number; a: number };
Example usage:const [setRiveRef, riveRef] = useRive();
const setBoolean = () => {
if (riveRef) {
riveRef.setBoolean('My Boolean Property', true);
}
};
const setString = () => {
if (riveRef) {
riveRef.current.setString('My String Property', 'Hello, Rive');
}
};
const setNumber = () => {
if (riveRef) {
riveRef.current.setNumber('My Number Property', 10);
}
};
const setColor = () => {
if (riveRef) {
riveRef.setColor('My Color Property', { r: 255, g: 0, b: 0, a: 1 });
// or
riveRef.setColor('My Color Property', '#00FF00FF');
}
};
const setEnum = () => {
if (riveRef) {
riveRef.setEnum('My Enum Property', 'Option 1');
}
};
const trigger = () => {
if (riveRef) {
riveRef.trigger('My Trigger Property');
}
};
Nested Property Paths
View models can have properties of type view model, allowing for arbitrary nesting. You can chain property calls on each instance starting from the root until you get to the property of interest. Alternatively, you can do this through a path parameter, which is similar to a URI in that it is a forward slash delimited list of property names ending in the name of the property of interest.
Access nested properties by providing the full path (separated by /) as the first argument to the property hooks.import { useRiveString, useRiveNumber, useRiveFile, useViewModelInstance } from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
// Accessing 'settings/theme/name' (String)
const { value: themeName, setValue: setThemeName } = useRiveString(
'settings/theme/name',
instance
);
// Accessing 'settings/volume' (Number)
const { value: volume, setValue: setVolume } = useRiveNumber(
'settings/volume',
instance
);
console.log('Current theme:', themeName);
// setThemeName('Dark Mode');
// setVolume(80);
The Rive React Native runtime does not yet support accessing a ViewModel property directly, to be able to do the chain notation.
The Rive React Native runtime does not support accessing nested properties using the chain notation.
But you can access nested properties using the path notation.
const [setRiveRef, riveRef] = useRive();
const nestedNumberByPath = useRiveNumber(riveRef, 'My Nested View Model/My Second Nested VM/My Nested Number');
useEffect(() => {
if (nestedNumberByPath) {
nestedNumberByPath.setValue(10);
}
}, [nestedNumberByPath]);
Observability
You can observe changes over time to property values, either by using listeners or a platform equivalent method. Once observed, you will be notified when the property changes are applied by a state machine advance, whether that is a new value that has been explicitly set or if the value was updated as a result of a binding.
Values are observed automatically through hooks. When a property’s value changes within the Rive instance (either because you set it via a hook or due to an internal binding), the value returned by the corresponding hook updates. This state change triggers a re-render of your React component, allowing you to react to the new value.For Triggers, you can provide an onTrigger callback directly to the useRiveTrigger hook, which fires when the trigger is activated in the Rive instance.import {
useRiveFile,
useViewModelInstance,
useRiveBoolean,
useRiveString,
useRiveNumber,
useRiveColor,
useRiveEnum,
useRiveTrigger,
useEffect
} from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
const { value: boolValue, setValue: setBoolValue } = useRiveBoolean('My Boolean Property', instance);
const { value: stringValue, setValue: setStringValue } = useRiveString('My String Property', instance);
const { value: numberValue, setValue: setNumberValue } = useRiveNumber('My Number Property', instance);
const { value: colorValue, setValue: setColorValue } = useRiveColor('My Color Property', instance);
const { value: enumValue, setValue: setEnumValue } = useRiveEnum('My Enum Property', instance);
const { trigger: triggerButton } = useRiveTrigger('My Trigger Property', instance, {
onTrigger: () => {
console.log('Trigger fired');
}
});
useEffect(() => {
if (numberValue !== undefined) {
console.log('numberValue changed:', numberValue);
}
}, [numberValue]);
const handleButtonPress = () => {
triggerButton();
};
The useRiveTrigger hook returns a trigger function that can be called to fire the trigger. This hook accepts an optional onTrigger callback in its third parameter that will be executed when the trigger is fired.
Values are observed through hooks.const [setRiveRef, riveRef] = useRive();
const [boolValue, setBoolValue] = useRiveBoolean(riveRef, 'My Boolean Property');
const [stringValue, setStringValue] = useRiveString(riveRef, 'My String Property');
const [numberValue, setNumberValue] = useRiveNumber(riveRef, 'My Number Property');
const [colorValue, setColorValue] = useRiveColor(riveRef, 'My Color Property');
const [enumValue, setEnumValue] = useRiveEnum(riveRef, 'My Enum Property');
const triggerButton = useRiveTrigger(riveRef, 'My Trigger Property', () => {
console.log('Trigger fired');
});
useEffect(() => {
if (numberValue !== undefined) {
console.log('numberValue changed:', numberValue);
}
}, [numberValue]);
const handleButtonPress = () => {
if (triggerButton) {
triggerButton();
}
};
The useRiveTrigger hook does not return a value, but instead takes a callback function as its third argument.
This callback will be executed when the trigger is fired.
Images
Image properties let you set and replace raster images at runtime, with each instance of the image managed independently. For example, you could build an avatar creator and dynamically update features — like swapping out a hat — by setting a view model’s image property.
Image properties can be set using the imageProperty method on a ViewModelInstance and the RiveImages utility for loading images.import {
useRive,
useRiveFile,
useViewModelInstance,
RiveView,
RiveImages,
type RiveViewRef
} from '@rive-app/react-native';
import { useRef } from 'react';
const { riveViewRef, setHybridRef } = useRive();
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
const riveViewRef = useRef<RiveViewRef>(undefined);
const handleLoadImage = async () => {
if (!riveViewRef) return;
const vmi = riveViewRef.getViewModelInstance();
if (!vmi) return;
const imgProp = vmi.imageProperty('imageValue');
if (!imgProp) return;
// Load image from URL
const riveImage = await RiveImages.loadFromURLAsync(
'https://picsum.photos/id/372/500/500'
);
imgProp.set(riveImage);
riveViewRef.playIfNeeded();
};
return (
<RiveView
hybridRef={setHybridRef}
file={riveFile}
dataBind={instance}
autoPlay={true}
/>
);
You can also add listeners to image properties:const imgProp = vmi.imageProperty('imageValue');
if (imgProp) {
imgProp.addListener(() => {
console.log('Image property changed!');
});
}
Other image loading options on RiveImages: /**
* Load an image from a bundled resource
* @param resource The resource name (e.g., "image.png")
* @returns A promise that resolves to the loaded RiveImage
*/
loadFromResourceAsync(resource: string): Promise<RiveImage>;
/**
* Load an image from raw bytes
* @param bytes The image data as an ArrayBuffer
* @returns A promise that resolves to the loaded RiveImage
*/
loadFromBytesAsync(bytes: ArrayBuffer): Promise<RiveImage>;
Image data binding is not supported on the legacy runtime.
Lists
List properties let you manage a dynamic set of view model instances at runtime. For example, you can build a TODO app where users can add and remove tasks in a scrollable Layout.
See the Editor section on creating data bound lists.
A single list property can include different view model types, with each view model tied to its own Component, making it easy to populate a list with a varity of Component instances.
With list properties, you can:
- Add a new view model instance (optionally at an index)
- Remove an existing view model instance (optionally by index)
- Swap two view model instances by index
- Get the size of a list
For more information on list properties, see the Data Binding List Property editor documentation.
Use the useRiveList hook to manage list properties on view model instances.import {
useRiveFile,
useViewModelInstance,
useRiveList,
RiveView
} from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
// Get the list property with manipulation functions
const {
length,
getInstanceAt,
addInstance,
addInstanceAt,
removeInstance,
removeInstanceAt,
swap,
error
} = useRiveList('todos', instance);
// Add a new todo item
const handleAddItem = () => {
const todoItemViewModel = riveFile?.viewModelByName('TodoItem');
if (todoItemViewModel) {
const newTodoItem = todoItemViewModel.createInstance();
if (newTodoItem) {
// Set some initial values
newTodoItem.stringProperty('description')?.set('Buy groceries');
addInstance(newTodoItem);
}
}
};
// Insert item at specific index
const handleInsertItem = () => {
const todoItemViewModel = riveFile?.viewModelByName('TodoItem');
if (todoItemViewModel) {
const newTodoItem = todoItemViewModel.createInstance();
if (newTodoItem) {
addInstanceAt(newTodoItem, 0); // Insert at beginning
}
}
};
// Remove first item by instance
const handleRemoveFirst = () => {
const firstInstance = getInstanceAt(0);
if (firstInstance) {
removeInstance(firstInstance);
}
};
// Remove item by index
const handleRemoveAt = () => {
if (length > 0) {
removeInstanceAt(0);
}
};
// Swap two items
const handleSwap = () => {
if (length >= 2) {
swap(0, 1);
}
};
console.log(`List has ${length} items`);
return (
<RiveView
file={riveFile}
dataBind={instance}
autoPlay={true}
/>
);
List data binding is not supported on the legacy runtime.
Artboards
Artboard properties allows you to swap out entire components at runtime. This is useful for creating modular components that can be reused across different designs or applications, for example:
- Creating a skinning system that supports a large number of variations, such as a character creator where you can swap out different body parts, clothing, and accessories.
- Creating a complex scene that is a composition of various artboards loaded from various different Rive files (drawn to a single canvas/texture/widget).
- Reducing the size (complexity) of a single Rive file by breaking it up into smaller components that can be loaded on demand and swapped in and out as needed.
Artboard properties work with the BindableArtboard class. Use getBindableArtboard on a RiveFile to create a bindable reference, then set it on the artboard property.// Get artboard property from view model instance
const artboardProp = instance.artboardProperty('CharacterArtboard');
// Create a bindable artboard and set it
const bindableArtboard = riveFile.getBindableArtboard('Character 1');
artboardProp?.set(bindableArtboard);
Artboard data binding is not supported on the legacy runtime.
Enums
Enums properties come in two flavors: system and user-defined. In practice, you will not need to worry about the distinction, but just be aware that system enums are available in any Rive file that binds to an editor-defined enum set, representing options from the editor’s dropdowns, where user-defined enums are those defined by a designer in the editor.
Enums are string typed. The Rive file contains a list of enums. Each enum in turn has a name and a list of strings.
You can access enum properties using the useRiveEnum hook. The hook returns the current value and a setter function.import {
useRiveFile,
useViewModelInstance,
useRiveEnum,
RiveView
} from '@rive-app/react-native';
const { riveFile } = useRiveFile(require('./my_file.riv'));
const instance = useViewModelInstance(riveFile);
const { value: category, setValue: setCategory, error } = useRiveEnum(
'category',
instance
);
// Set enum value
setCategory('option_name');
return (
<RiveView
file={riveFile}
dataBind={instance}
autoPlay={true}
/>
);
Retrieving the list of all enums in the file, or accessing all possible values on an Enum, is not yet available.
Retrieving the list of enums is not supported on the legacy API.
Examples